Attribute VB_Name = "Module1"
Global Chiffre(19) As String
Public Sub InitChiffre()
Chiffre(0) = "Zero": Chiffre(1) = "Un"
Chiffre(2) = "Deux": Chiffre(3) = "Trois"
Chiffre(4) = "Quatre": Chiffre(5) = "Cinq"
Chiffre(6) = "Six": Chiffre(7) = "Sept"
Chiffre(8) = "Huit": Chiffre(9) = "Neuf"
Chiffre(10) = "Dix": Chiffre(11) = "Onze"
Chiffre(12) = "Douze": Chiffre(13) = "Treize"
Chiffre(14) = "Quatorze": Chiffre(15) = "Quinze"
Chiffre(16) = "Seize": Chiffre(17) = "Dix-Sept"
Chiffre(18) = "Dix-Huit": Chiffre(19) = "Dix-Neuf"
End Sub

Public Function Conversion(u As Variant) As String
Dim CNum As String
Dim Chaine As String
'
InitChiffre
'
Chaine = ""
CNum = "000000000000" & u
CNum = Right$(CNum, 12)
'
'*** Milliard
Z$ = Mid$(CNum, 1, 3)
If Z$ <> "000" Then
                r$ = CvCentaine(Z$)
                Chaine = Chaine & r$ & " Millard"
                If Z$ <> "001" Then Chaine = Chaine & "s"
                End If
'*** Million
Z$ = Mid$(CNum, 4, 3)
If Z$ <> "000" Then
                r$ = " " & CvCentaine(Z$)
                Chaine = Chaine & r$ & " Million"
                If Z$ <> "001" Then Chaine = Chaine & "s"
                End If
'*** Mille
Z$ = Mid$(CNum, 7, 3)
If Z$ <> "000" Then
                If Z$ = "001" Then
                    Chaine = Chaine & " Mille"
                    Else
                    r$ = " " & CvCentaine(Z$)
                    Chaine = Chaine & r$ & " Mille"
                End If
                End If
'*** Cent
Z$ = Mid$(CNum, 10, 3)
If Z$ <> "000" Then
                If Z$ = "100" Then
                    Chaine = Chaine & " Cent"
                    Else
                    Chaine = Chaine & " " & CvCentaine(Z$)
                    End If
                End If
Chaine = Trim$(Chaine)
If (Right$(Chaine, 4) = "Cent") And (Left$(Z$, 1) > "1") Then Chaine = Chaine & "s"
If (Right$(Chaine, 12) = "Quatre-Vingt") Then Chaine = Chaine & "s"
If Chaine = "" Then Chaine = "Zero"
Conversion = Chaine
End Function
Public Function CvCentaine(Zc$) As String
uc% = Val(Left$(Zc$, 1))
rd$ = CvDizaine(Right$(Zc$, 2))
Select Case uc%
        Case 0
            CvCentaine = rd$
        Case 1
            If rd$ = "Zero" Then rd$ = ""
            CvCentaine = "Cent " & rd$
        Case Else
            If rd$ = "Zero" Then rd$ = ""
            CvCentaine = Chiffre(uc%) & " Cent " & rd$
End Select
End Function
Public Function CvDizaine(Z$) As String
ud% = Val(Z$)
uu% = Val(Right$(Z$, 1))
Select Case ud%
    Case Is < 20
        CvDizaine = Chiffre(ud%)
    Case Is < 30
        CvDizaine = "Vingt" & Fmdizaine(uu%, 0)
    Case Is < 40
        CvDizaine = "Trente" & Fmdizaine(uu%, 0)
    Case Is < 50
        CvDizaine = "Quarante" & Fmdizaine(uu%, 0)
    Case Is < 60
        CvDizaine = "Cinquante" & Fmdizaine(uu%, 0)
    Case Is < 70
        CvDizaine = "Soixante" & Fmdizaine(uu%, 0)
    Case Is < 80
        If uu% < 7 Then
            CvDizaine = "Soixante-" & Chiffre(uu% + 10)
            Else
            CvDizaine = "Soixante " & Chiffre(uu% + 10)
            End If
            
    Case Is < 90
        CvDizaine = "Quatre-Vingt" & Fmdizaine(uu%, 1)
    Case Is < 100
        CvDizaine = "Quatre-Vingt " & Chiffre(uu% + 10)
End Select
    
End Function
Public Function Fmdizaine(uu%, flg%) As String
Select Case uu%
    Case 0: Fmdizaine = ""
    Case 1
        If flg% = 0 Then
                Fmdizaine = " et Un"
                Else
                Fmdizaine = " Un"
                End If
    Case Else
        If flg% = 0 Then
                Fmdizaine = "-" & Chiffre(uu%)
                Else
                Fmdizaine = " " & Chiffre(uu%)
                End If
End Select
End Function
